CVE-2003-0326
CVSS4.6
发布时间 :2003-06-09 00:00:00
修订时间 :2016-10-17 22:32:30
NMCOS    

[原文]Integer overflow in parse_decode_path() of slocate may allow attackers to execute arbitrary code via a LOCATE_PATH with a large number of ":" (colon) characters, whose count is used in a call to malloc.


[CNNVD]SLocate路径分配整数溢出导致堆破坏漏洞(CNNVD-200306-043)

        
        slocate是一款查找文件和目录的工具,slocate本身具有一个数据库,里面存放了系统中文件与目录的相关信息。
        slocate当处理环境变量SLOCATE_PATH数据时存在问题,本地攻击者可以利用这个漏洞进行基于堆的溢出,可能以root用户权限在系统上执行任意指令。
        问题存在于main.c中的parse_decode_path函数,此函数通过getenv("LOCATE_PATH")获得环境变量,但是此变量的分配可以由外部用户控制,如:
        while ((part = strchr(part+1, ':'))) i++;
        上面的part可以由用户提供,并可以使i为一个非常大的值,当后续进行malloc()操作的时:
        SLOCATE_PATH = malloc(i * sizeof(char *));
        就可以导致malloc()分配过小而发生基于堆的整数溢出,精心构建提交数据可能以root用户权限在系统上执行任意指令。
        

- CVSS (基础分值)

CVSS分值: 4.6 [中等(MEDIUM)]
机密性影响: PARTIAL [很可能造成信息泄露]
完整性影响: PARTIAL [可能会导致系统文件被修改]
可用性影响: PARTIAL [可能会导致性能下降或中断资源访问]
攻击复杂度: LOW [漏洞利用没有访问限制 ]
攻击向量: LOCAL [漏洞利用需要具有物理访问权限或本地帐户]
身份认证: NONE [漏洞利用无需身份认证]

- CPE (受影响的平台与产品)

产品及版本信息(CPE)暂不可用

- OVAL (用于检测的技术细节)

未找到相关OVAL定义

- 官方数据库链接

http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2003-0326
(官方数据源) MITRE
http://web.nvd.nist.gov/view/vuln/detail?vulnId=CVE-2003-0326
(官方数据源) NVD
http://www.cnnvd.org.cn/vulnerability/show/cv_cnnvdid/CNNVD-200306-043
(官方数据源) CNNVD

- 其它链接及资源

http://marc.info/?l=bugtraq&m=105337692202626&w=2
(UNKNOWN)  BUGTRAQ  20030519 bazarr slocate
http://www.securityfocus.com/bid/7629
(UNKNOWN)  BID  7629

- 漏洞信息

SLocate路径分配整数溢出导致堆破坏漏洞
中危 边界条件错误
2003-06-09 00:00:00 2005-10-20 00:00:00
本地  
        
        slocate是一款查找文件和目录的工具,slocate本身具有一个数据库,里面存放了系统中文件与目录的相关信息。
        slocate当处理环境变量SLOCATE_PATH数据时存在问题,本地攻击者可以利用这个漏洞进行基于堆的溢出,可能以root用户权限在系统上执行任意指令。
        问题存在于main.c中的parse_decode_path函数,此函数通过getenv("LOCATE_PATH")获得环境变量,但是此变量的分配可以由外部用户控制,如:
        while ((part = strchr(part+1, ':'))) i++;
        上面的part可以由用户提供,并可以使i为一个非常大的值,当后续进行malloc()操作的时:
        SLOCATE_PATH = malloc(i * sizeof(char *));
        就可以导致malloc()分配过小而发生基于堆的整数溢出,精心构建提交数据可能以root用户权限在系统上执行任意指令。
        

- 公告与补丁

        厂商补丁:
        slocate
        -------
        目前厂商还没有提供补丁或者升级程序,我们建议使用此软件的用户随时关注厂商的主页以获取最新版本:

- 漏洞信息

6199
Linux slocate parse_decode_path() Overflow
Local Access Required Input Manipulation
Loss of Confidentiality, Loss of Integrity
Exploit Public

- 漏洞描述

A local overflow exists in slocate for Linux. The product fails to handle input of over 536870912 bytes resulting in a integer overflow. With a specially crafted request, an attacker can cause privilege escalation resulting in a loss of confidentiality and integrity.

- 时间线

2003-05-19 2003-05-19
2003-05-19 Unknow

- 解决方案

Currently, there are no known upgrades, patches, or workarounds available to correct this issue.

- 相关参考

- 漏洞作者

- 漏洞信息

SLocate Path Malloc Integer Signing Heap Overflow Vulnerability
Boundary Condition Error 7629
No Yes
2003-05-20 12:00:00 2009-07-11 10:06:00
Vulnerability discovery credited to "bazarr@ziplip.com" <bazarr@ziplip.com>.

- 受影响的程序版本

slocate slocate 2.7
+ MandrakeSoft Corporate Server 3.0 x86_64
+ MandrakeSoft Corporate Server 3.0
+ MandrakeSoft Corporate Server 2.1 x86_64
+ MandrakeSoft Corporate Server 2.1
+ Mandriva Linux Mandrake 10.2 x86_64
+ Mandriva Linux Mandrake 10.2
+ Mandriva Linux Mandrake 10.1 x86_64
+ Mandriva Linux Mandrake 10.1
+ Mandriva Linux Mandrake 10.0 AMD64
+ Mandriva Linux Mandrake 10.0
slocate slocate 2.6
+ Caldera OpenLinux Server 3.1.1
+ Caldera OpenLinux Workstation 3.1.1
+ Conectiva Linux 8.0
+ Conectiva Linux 7.0
+ Conectiva Linux 6.0
+ Debian Linux 3.0 sparc
+ Debian Linux 3.0 s/390
+ Debian Linux 3.0 ppc
+ Debian Linux 3.0 mipsel
+ Debian Linux 3.0 mips
+ Debian Linux 3.0 m68k
+ Debian Linux 3.0 ia-64
+ Debian Linux 3.0 ia-32
+ Debian Linux 3.0 hppa
+ Debian Linux 3.0 arm
+ Debian Linux 3.0 alpha
+ Gentoo Linux 1.4 _rc2
+ Gentoo Linux 1.4 _rc1
+ MandrakeSoft Corporate Server 2.1 x86_64
+ MandrakeSoft Corporate Server 2.1
+ Mandriva Linux Mandrake 9.2 amd64
+ Mandriva Linux Mandrake 9.2
+ Mandriva Linux Mandrake 9.1 ppc
+ Mandriva Linux Mandrake 9.1
+ RedHat Linux 9.0 i386
+ RedHat Linux 8.0 i386
+ RedHat Linux 7.3 i386
+ RedHat Linux 7.2 i386
+ Trustix Secure Linux 2.0
+ Trustix Secure Linux 1.5
slocate slocate 2.5
slocate slocate 2.4
slocate slocate 2.3
slocate slocate 2.2
slocate slocate 2.1
+ Red Hat Linux 6.2

- 漏洞讨论

It has been reported that slocate is vulnerable to an issue when handling data in the environment variable SLOCATE_PATH. Because of this problem, it may be possible for a local attacker to cause a heap corruption issue, potentially executing code.

- 漏洞利用

Currently we are not aware of any exploits for this issue. If you feel we are in error or are aware of more recent information, please mail us at: vuldb@securityfocus.com &lt;mailto:vuldb@securityfocus.com&gt;.

- 解决方案

Currently we are not aware of any vendor-supplied patches for this issue. If you feel we are in error or are aware of more recent information, please mail us at: vuldb@securityfocus.com <mailto:vuldb@securityfocus.com>.

- 相关参考

 

 

关于SCAP中文社区

SCAP中文社区是国内第一个以SCAP为主题的中文开放社区。了解更多信息,请查阅[关于本站]

版权声明

CVE/CWE/OVAL均为MITRE公司的注册商标,它们的官方数据源均保存在MITRE公司的相关网站